=== debian/changelog ===
openimageio (1.6.17~dfsg0-1) unstable; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Fri, 02 Sep 2016 13:56:02 +0200

openimageio (1.6.16~dfsg0-1) unstable; urgency=medium

  * New upstream release
    - debian/patches/: patchset updated
      - 0003-Fix_OpenJPEG2_build.patch dropped (applied upstream)

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 04 Aug 2016 22:49:46 +0200

openimageio (1.6.15~dfsg0-2) unstable; urgency=medium

  * debian/control: b-dep libopenjpeg-dev -> libopenjp2-7-dev
  * debian/control: dh-python b-dep added
  * debian/patches/: patchset updated
    - 0003-Fix_OpenJPEG2_build.patch added (Closes: #826823)
      Thanks to Larry Gritz (upstream) for the patch.

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 19 Jul 2016 15:09:05 +0200

openimageio (1.6.15~dfsg0-1) unstable; urgency=medium

  * New upstream release (Closes: #812051)

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 02 Jul 2016 13:50:20 +0200
