=== debian/watch ===
version=3
opts="dversionmangle=s/\~dfsg.*//" \
https://github.com/OpenImageIO/oiio/tags .*/Release-(\d.*[^dev])\.(?:tgz|tar\.(?:gz|bz2|xz))
